#pragma once

#include <windows.h>
#include <mmsystem.h>
#include "aviutl_sdk/output.h"
#include "common.h"

namespace ruche {
namespace aviutl {
namespace plugins
{
    // o̓vOCC^tF[X擾邽߂API֐^B
    typedef OUTPUT_PLUGIN_TABLE* (CALLBACK* Func_GetOutputPluginTable)();

    // o̓^Cv\񋓃tOlB
    [System::Flags]
    public enum class OutputFlags
    {
        // 摜o͂B
        Video = OUTPUT_INFO_FLAG_VIDEO,

        // o͂B
        Audio = OUTPUT_INFO_FLAG_AUDIO,
    };

    // o͂rfIt[̏\񋓃tOlB
    [System::Flags]
    public enum class OutputVideoFrameFlags
    {
        // tO
        None = 0,

        // L[t[
        KeyFrame = OUTPUT_INFO_FRAME_FLAG_KEYFRAME,

        // Rs[t[
        CopyFrame = OUTPUT_INFO_FRAME_FLAG_COPYFRAME,
    };

    // YUY2ϊɂUV̗̍p@\񋓒lB
    public enum class Yuy2UVType
    {
        // sNZ̗pB
        LeftOrigin,

        // EsNZ̗pB
        RightOrigin,

        // ϒl̗pB
        Average,
    };
}
}}
