using System;
using System.Collections.Generic;
using System.Text;

namespace ruche.nive2.aviutlPluginPorts
{
    /// <summary>
    /// \\́B
    /// </summary>
    [Serializable]
    public struct Fraction
    {
        /// <summary>
        /// qB
        /// </summary>
        public int Numerator;

        /// <summary>
        /// B
        /// </summary>
        public int Denominator;

        /// <summary>
        /// _ŏRXgN^B
        /// </summary>
        /// <param name="value">_B</param>
        public Fraction(double value)
        {
            // ۑ
            bool minus = (value < 0);
            value = Math.Abs(value);

            long n, d = 1;
            while (true)
            {
                // qlől𒴂ĂO
                n = (long)value;
                if (n > int.MaxValue)
                {
                    // ŏ璴Ăꍇɂ͗Ȃ
                    throw new ArgumentOutOfRangeException(
                        "value", value,
                        "_l𕪐lɕϊł܂B");
                }

                // qlɏ_ȉ܂܂ȂȂOK
                if (value == (double)n) { break; }

                // ql10{ƍől𒴂Ă܂ȂË
                value *= 10;
                if (value > (double)int.MaxValue) { break; }

                // l10{ƍől𒴂Ă܂ȂË
                d *= 10;
                if (d > int.MaxValue)
                {
                    d /= 10;
                    break;
                }
            }

            // lݒ
            Numerator = (int)(minus ? -n : n);
            Denominator = (int)d;
        }
    }
}
